'-----------------------------------------------------------------------------------------
'name                     : tcpip.bas
'copyright                : (c) 1995-2005, MCS Electronics
'purpose                  : demo: CONFIG TCPIP
'micro                    : Mega88
'suited for demo          : yes
'commercial addon needed  : only hardware
'-----------------------------------------------------------------------------------------

$regfile = "M88def.dat"
$crystal = 8000000
$baud = 19200

Const Sock_stream = $01                                     ' Tcp
Const Sock_dgram = $02                                      ' Udp
Const Sock_ipl_raw = $03                                    ' Ip Layer Raw Sock
Const Sock_macl_raw = $04                                   ' Mac Layer Raw Sock
Const Sel_control = 0                                       ' Confirm Socket Status
Const Sel_send = 1                                          ' Confirm Tx Free Buffer Size
Const Sel_recv = 2                                          ' Confirm Rx Data Size

'socket status
Const Sock_closed = $00                                     ' Status Of Connection Closed
Const Sock_arp = $01                                        ' Status Of Arp
Const Sock_listen = $02                                     ' Status Of Waiting For Tcp Connection Setup
Const Sock_synsent = $03                                    ' Status Of Setting Up Tcp Connection
Const Sock_synsent_ack = $04                                ' Status Of Setting Up Tcp Connection
Const Sock_synrecv = $05                                    ' Status Of Setting Up Tcp Connection
Const Sock_established = $06                                ' Status Of Tcp Connection Established
Const Sock_close_wait = $07                                 ' Status Of Closing Tcp Connection
Const Sock_last_ack = $08                                   ' Status Of Closing Tcp Connection
Const Sock_fin_wait1 = $09                                  ' Status Of Closing Tcp Connection
Const Sock_fin_wait2 = $0a                                  ' Status Of Closing Tcp Connection
Const Sock_closing = $0b                                    ' Status Of Closing Tcp Connection
Const Sock_time_wait = $0c                                  ' Status Of Closing Tcp Connection
Const Sock_reset = $0d                                      ' Status Of Closing Tcp Connection
Const Sock_init = $0e                                       ' Status Of Socket Initialization
Const Sock_udp = $0f                                        ' Status Of Udp
Const Sock_raw = $10                                        ' Status of IP RAW


Const Epr = 1


Print "Init , set IP to 192.168.0.8"                        ' display a message
Enable Interrupts                                           ' before we use config tcpip , we need to enable the interrupts
Config Tcpip = Int0 , Mac = 12.128.12.34.56.78 , Ip = 192.168.0.8 , Submask = 255.255.255.0 , Gateway = 192.168.0.1 , Localport = 1000 , Tx = $55 , Rx = $55 , Twi = &H80 , Clock = 400000
Print "Init Done"



'The next code is optional. It shows how to change the IP at run time
#if Epr = 1
    Dim Xx As Eram Long                                     ' this is 4 bytes of EEPROM
    Dim Zz As Long                                          ' this is a long
    Zz = Xx                                                 ' read eeprom
    Dim B4 As Byte
    B4 = 8

    'use maketcp to create an IP number
    'notice that last param is a variable.
    'all bytes could be variables of course
    Zz = Maketcp(192 , 168 , 0 , B4)

    'in reverse order
    Zz = Maketcp(b4 , 9 , 168 , 192 , 1)

    'simplest form
    Zz = Maketcp(192.168.0.8)

    Print Ip2str(zz)
    Settcp 12.128.12.34.56.78 , Zz , 255.255.255.0 , 0.0.0.0
    '                            ^   notice the variable that holds the IP address 192.168.0.8
    '                                from the EEPROM data line below
#endif

Do
  nop
  ' a ping should now work
Loop
End


End


$eeprom
' take care, data is stored byte, by byte so reversed notation is used
Data 8 , 0 , 168 , 192                                      '   this is 192 , 168 , 0 , 8
$data